pbsnodes(8B)

NAME
pbsnodes - query PBS host or vnode status, mark hosts free or offline, change the comment for a host, or output vnode information

SYNOPSIS
pbsnodes [-o | -r] [-s <server>] [-C <comment>] <hostname> [<hostname> ...] pbsnodes [-l] [-s <server>] pbsnodes -v <vnode> [<vnode> ...] [-s <server>] pbsnodes -a[v] [-S[j][L]] [-F json|dsv [-D <delim>]] [-s <server>] pbsnodes [-H] [-S[j][L]] [-F json|dsv [-D <delim>]] <hostname> [<hostname> ...] pbsnodes --version

DESCRIPTION
The pbsnodes command is used to query the status of hosts or vnodes, to mark hosts FREE or OFFLINE, to edit a host's comment attribute, or to output vnode information. The pbsnodes command obtains host information by sending a request to the PBS server.

To print the status of the specified host or hosts, run pbsnodes with no options (except the -s option) and with a list of hosts.

To print the command usage, run pbsnodes with no options and without a list of hosts. To remove a node from the scheduling pool, mark it OFFLINE. If it is marked DOWN, when the server next queries the MoM, and can connect, the node will be marked FREE. To offline a single vnode in a multi-vnoded system, use:
    qmgr: set node <vnode name> state=offline

OUTPUT
The order in which hosts or vnodes are listed in the output of the pbsnodes command is undefined. Do not rely on output being ordered. If you print attributes, pbsnodes prints out only those attributes which are not at default values.

PERMISSIONS
PBS Manager or Operator privilege is required to execute pbsnodes with the -o or -r options. Operator or Manager privilege is required to view custom resources which have been created to be invisible to users, and to see some output such as PBS version.

OPTIONS

(no options)
    If neither options nor a host list is given, the pbsnodes command prints usage syntax.

-a  Lists all hosts and all their attributes (available and used.) When listing a host with multiple vnodes:

        The output for the jobs attribute lists all the jobs on all the vnodes on that host. Jobs that run on more than one vnode will appear once for each vnode they run on. For consumable resources, the output for each resource is the sum of that resource across all vnodes on that host. For all other resources, e.g. string and Boolean, if the value of that resource is the same on all vnodes on that host, the value is returned. Otherwise the output is the literal string "<various>".

-C <comment>
    Sets the comment attribute for the specified host(s) to the value of <comment>. Comments containing spaces must be quoted. The comment string is limited to 80 characters. Usage:
    pbsnodes -C <comment> <hostname> [<hostname> ...] To set the comment for a vnode:
    qmgr -c s n <vnode name> comment=<comment>

-F dsv [-D <delim>]
    Prints output in delimiter-separated value format. Optional delimiter specification. Default delimiter is vertical bar ("|").

-F json
    Prints output in JSON format.

-H <host> [<host> ...]
    Prints all non-default-valued attributes for specified hosts and all vnodes on specified hosts.

-j  Displays the following job-related headers for specified vnodes:
    Header     Width  Description
    ------------------------------------
    vnode       15    Vnode name
    state       15    Vnode state
    njobs        6    Number of jobs on vnode
    run          5    Number of running jobs at vnode
    susp         6    Number of suspended jobs at vnode
    mem f/t     12    Vnode memory free/total
    ncpus f/t    7    Number of CPUs at vnode free/total
    nmics f/t    7    Number of MICs at vnode free/total
    ngpus f/t    7    Number of GPUs at vnode free/total
    jobs        any   List of job IDs on vnode
    Note that nmics and ngpus are custom resources that must be created by the administrator if you want them displayed here. Each subjob is treated as a unique job.

-L  Displays output with no restrictions on column width.

-l  Lists all hosts marked as DOWN or OFFLINE. Each such host's state and comment attribute (if set) is listed. If a host also has state STATE-UNKNOWN, it is listed. For hosts with multiple vnodes, only hosts where all vnodes are marked as DOWN or OFFLINE are listed.

-o <hostname> [<hostname> ...]
    Marks listed hosts as OFFLINE even if currently in use. This is different from being marked DOWN. A host that is marked OFFLINE continues to execute the jobs already on it, but is removed from the scheduling pool (no more jobs are scheduled on it.) Offlines ALL vnodes on a Cray. For non-Cray hosts with multiple vnodes, pbsnodes operates on a host and all of its vnodes, where the hostname is resources_available.host, which is the name of the natural vnode. To offline all vnodes on a non-Cray multi-vnoded machine:
    pbsnodes -o <name of natural vnode> For Cray hosts with multiple vnodes, note that login nodes share a name with compute nodes, so if you use this option on a Cray, you will offline ALL of your compute nodes. To offline a single vnode on a Cray or another multi-vnoded system, use:
    qmgr -c set node <vnode name> state=offline Requires PBS Manager or Operator privilege.

-r <hostname> [<hostname> ...]
    Clears OFFLINE from listed hosts.

-S  Displays the following vnode information:
    Header     Width  Description
    ------------------------------------
    name        15    Vnode name
    state       15    Vnode state
    OS           8    Value of OS custom resource, if any
    hardware     8    Value of hardware custom resource, if any
    host        15    Hostname
    queue       10    Value of vnode's queue attribute
    ncpus        7    Number of CPUs at vnode
    nmics        7    Number of MICs at vnode
    mem         12    Vnode memory
    ngpus        7    Number of GPUs at vnode
    comment     any   Vnode comment
    Note that nmics, ngpus, and OS are custom resources that must be created by the administrator if you want their values displayed here.

-s <server>
    Specifies the PBS server to which to connect.

-v <vnode> [<vnode> ...]
    Lists all non-default-valued attributes for each specified vnode.
    With no arguments, prints one entry for each vnode in the PBS complex.
    With one or more vnodes specified, prints on entry for each specified vnode.

--version
    The pbsnodes command returns its PBS version information and exits. This option can only be used alone.

OPERANDS

<server>
    Specifies the server to which to connect. Default: default server.

<hostname> [<hostname> ...]
    Specifies the host(s) to be queried or operated on.

<vnode> [<vnode> ...]
    Specifies the vnode(s) to be queried or operated on.

EXIT STATUS

Zero
    Success

Greater than zero
    Incorrect operands are given
    pbsnodes cannot connect to the server
    There is an error querying the server for the vnodes

SEE ALSO
The PBS Professional Administrator's Guide,
pbs_server(8B) and qmgr(8B)